%module  dolfin_4bedd8911ad2fa3696d85d184d02a288d3294659
//%module (directors="1") dolfin_4bedd8911ad2fa3696d85d184d02a288d3294659

//%feature("director");

%{
#include <iostream>

#include <cmath>
#include <iostream>
#include <complex>
#include <stdexcept>
#include <numpy/arrayobject.h>
#include <memory>
#include <dolfin/common/types.h>
#include <dolfin/math/basic.h>
#include <dolfin/common/types.h>
#include <dolfin/common/constants.h>
#include <dolfin/common/Array.h>
#include <dolfin/common/Variable.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/Expression.h>
#include <dolfin/function/Function.h>
#include <dolfin/function/FunctionSpace.h>


namespace dolfin
{
  
  // cmath functions
  using std::cos;
  using std::sin;
  using std::tan;
  using std::acos;
  using std::asin;
  using std::atan;
  using std::atan2;
  using std::cosh;
  using std::sinh;
  using std::tanh;
  using std::exp;
  using std::frexp;
  using std::ldexp;
  using std::log;
  using std::log10;
  using std::modf;
  using std::pow;
  using std::sqrt;
  using std::ceil;
  using std::fabs;
  using std::floor;
  using std::fmod;
  using std::max;
  using std::min;
  
  const double pi = DOLFIN_PI;
  
  class Expression_57f7fc650b451f22211822809c475755660ff6b4: public Expression
  {
  public:
  
    Expression_57f7fc650b451f22211822809c475755660ff6b4():Expression()
    {
  
  
    }
  
    void eval(dolfin::Array<double>& values, const dolfin::Array<double>& x,
              const ufc::cell& cell) const
    {
      values[0] = 1/x[0];
    }
  
    void eval(dolfin::Array<double>& values, const dolfin::Array<double>& x) const
    {
      values[0] = 1/x[0];
    }
  };
  
}
%}

//%feature("autodoc", "1");


%init%{

%}



%init%{
import_array();
%}

// Include global SWIG interface files:
// Typemaps, shared_ptr declarations, exceptions, version
%include <std_shared_ptr.i>

// Global typemaps and forward declarations
%include "dolfin/swig/typemaps/includes.i"
%include "dolfin/swig/forwarddeclarations.i"

// Global exceptions
%include <exception.i>
%include "dolfin/swig/exceptions.i"

// Do not expand default arguments in C++ by generating two an extra
// function in the SWIG layer. This reduces code bloat.
%feature("compactdefaultargs");

// STL SWIG string class
%include <std_string.i>

// Manually import ufc:
%{
#include <ufc.h>
%}
%shared_ptr(ufc::function)
%shared_ptr(ufc::dofmap)
%shared_ptr(ufc::finite_element)
%shared_ptr(ufc::coordinate_mapping)
%shared_ptr(ufc::function)
%shared_ptr(ufc::form)
%ignore ufc::integral;
%ignore ufc::cell_integral;
%ignore ufc::exterior_facet_integral;
%ignore ufc::interior_facet_integral;
%ignore ufc::vertex_integral;
%ignore ufc::custom_integral;
%ignore ufc::cutcell_integral;
%ignore ufc::interface_integral;
%ignore ufc::overlap_integral;
%include <ufc.h>

// Local shared_ptr declarations
%shared_ptr(dolfin::GenericFunction)
%shared_ptr(dolfin::Variable)
%shared_ptr(dolfin::Expression)
%shared_ptr(dolfin::Expression_57f7fc650b451f22211822809c475755660ff6b4)



// Import statements

// %import types from submodule common of SWIG module common
%include "dolfin/swig/common/pre.i"
%import(package="", module="dolfin.cpp.common") "dolfin/common/types.h"
%import(package="", module="dolfin.cpp.common") "dolfin/common/constants.h"
%import(package="", module="dolfin.cpp.common") "dolfin/common/Array.h"
%import(package="", module="dolfin.cpp.common") "dolfin/common/Variable.h"

// %import types from submodule function of SWIG module function
%include "dolfin/swig/function/pre.i"
%import(package="", module="dolfin.cpp.function") "dolfin/function/GenericFunction.h"
%import(package="", module="dolfin.cpp.function") "dolfin/function/Expression.h"
%import(package="", module="dolfin.cpp.function") "dolfin/function/Function.h"
%import(package="", module="dolfin.cpp.function") "dolfin/function/FunctionSpace.h"

%feature("autodoc", "1");

%inline %{
int get_swigversion() { return  SWIGVERSION; }
%}

%pythoncode %{
tmp = hex(get_swigversion())
swigversion = "%d.%d.%d"%(tuple(map(int, [tmp[-5], tmp[-3], tmp[-2:]])))
del tmp, get_swigversion
%}



//
namespace dolfin
{
  
  // cmath functions
  using std::cos;
  using std::sin;
  using std::tan;
  using std::acos;
  using std::asin;
  using std::atan;
  using std::atan2;
  using std::cosh;
  using std::sinh;
  using std::tanh;
  using std::exp;
  using std::frexp;
  using std::ldexp;
  using std::log;
  using std::log10;
  using std::modf;
  using std::pow;
  using std::sqrt;
  using std::ceil;
  using std::fabs;
  using std::floor;
  using std::fmod;
  using std::max;
  using std::min;
  
  const double pi = DOLFIN_PI;
  
  class Expression_57f7fc650b451f22211822809c475755660ff6b4: public Expression
  {
  public:
  
    Expression_57f7fc650b451f22211822809c475755660ff6b4():Expression()
    {
  
  
    }
  
    void eval(dolfin::Array<double>& values, const dolfin::Array<double>& x,
              const ufc::cell& cell) const
    {
      values[0] = 1/x[0];
    }
  
    void eval(dolfin::Array<double>& values, const dolfin::Array<double>& x) const
    {
      values[0] = 1/x[0];
    }
  };
  
};

